;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of Crimson Knight Adventures: An Amstrad CPC Game
;;  Copyright (C) 2018 Carlos Soler Mujeriego / Enrique Vidal Cayuela / Alejandro
;;  Gutiérrez Martínez
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------

.include "main.h.s"
.include "player.h.s"
.include "collision.h.s"
.include "enemy.h.s"
border_up:   .db #9		;; Y = 8
border_down: .db #151	;; Y = 152
border_left: .db #6    ;; X = 24
border_right: .db #74    ;; X = 24

collision_handler::

ret




check_collision_ball:

	call check_collision_up
	call check_collision_down
	call check_collision_left
	call check_collision_right

ret


check_collision_up:

	ld  a, e_y(ix)
	ld  b, a
	ld  a, (border_up)
	sub b
	jr  z, no_collision_up
	jp  m, no_collision_up

		;;ld  a, e_vy(ix)
		xor a
		inc a
		;;ld  e_vy(ix), #4

	no_collision_up: 

ret

check_collision_down:

	ld  a, (border_down)
	ld  b, a
	ld  a, e_y(ix)
	ld  c, a
	ld  a, e_h(ix)
	add c
	sub b
	jr  z, no_collision_down
	jp  m, no_collision_down

		;;ld  a, e_vy(ix)
		xor a
		inc a
		;;ld  e_vy(ix), #-4
		;;ld  a, e_vy(ix)

	no_collision_down: 

ret

check_collision_left:

	ld  a, e_x(ix)
	ld  b, a
	ld  a, (border_left)
	sub b
	jr  z, no_collision_left
	jp  m, no_collision_left

		;;ld  a, e_vx(ix)
		xor a
		inc a
		;;ld  e_vx(ix), #1

	no_collision_left: 

ret

check_collision_right:


	ld  a, (border_right)
	ld  b, a
	ld  a, e_x(ix)
	ld  c, a
	ld  a, e_w(ix)
	add c
	sub b
	jr  z, no_collision_right
	jp  m, no_collision_right

		;;ld  a, e_vx(ix)
		xor a
		inc a
		;;ld  e_vx(ix), #-1
		;;ld  a, e_vx(ix)

	no_collision_right:   

ret

;;======================
;; COLLISON X
;; DESTROYS: A, B
;; INPUTS:
;; 		IX -> Entidad
;;		IY -> Entidad 2
;;		HL -> Metodo a devolver
;; =====================

collision_x:
	;;ld (metodo), hl
	
	;;Collision left
	ld a, en_x(ix) 		;; Get enemy X
	add a, en_w(ix)		;; Add enemy W to X
	inc a
	ld b, e_x(iy)       ;; Get player X
	sub b 				;; Substract B to A
	jp z, end_collision
	jp m, end_collision
	
	;;Collision right
	ld a, e_x(iy)
	add a, e_w(iy)
	inc a
	ld b, en_x(ix)
	sub b
	jp z, end_collision
	jp m, end_collision
	

	;;Collision up
	ld a, en_y(ix)
	add a, en_h(ix)
	inc a
	ld b, e_y(iy)
	sub b
	jp z, end_collision
	jp m, end_collision
	

	;;Collision down
	ld a, e_y(iy)
	add a, e_h(iy)
	inc a
	ld b, en_y(ix)
	sub b
	jp z, end_collision
	jp m, end_collision
	

	;;Hay colision
	;;metodo = . + 1
	;;call #00
	ld c, #1
	jp end_end

	end_collision:
	;; No hay colison
	ld c, #0

	end_end:
ret

;;======================
;; COLLISON WITH THE ENEMY VECTOR
;; DESTROYS:
;; INPUTS:
;; 		IX -> Entidad
;; =====================

enemy_vector_collision:

ret