;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of Crimson Knight Adventures: An Amstrad CPC Game
;;  Copyright (C) 2018 Carlos Soler Mujeriego / Enrique Vidal Cayuela / Alejandro
;;  Gutiérrez Martínez
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------

;;
;;	MACROS
;;

;;	DEFINE AN ENEMY
.macro DefineEnemy _name, _x, _y, _w, _h, _sprite_image, _vx, _vy, _upd, _collision, _hit_lag, _collision_upd, _hit_upd, _walking_animation, _damage, _hit_lag_cont, _type
	_name:
		.db 	_x, _y 				;; POSICION X, Y
		.db 	_w, _h 				;; WIDTH, HEIGHT
		.dw		_sprite_image		;; POINTER TO SPRITE

		.db 	_vx, _vy 			;; VELOCITY X, Y
		.dw 	_upd 				;; UPDATE METHOD
		.db 	_collision 			;; COLLISION VAR (0 = NON COLLISION, 1 = THERE IS A COLLISION)
		.db 	_hit_lag 			;; INTERVAL OF TIME TO HIT THE PLAYER
		.dw 	_collision_upd 		;; COLLIDE METHOD
		.dw 	_hit_upd 			;; HIT METHOD

		.db 	_walking_animation 	;; WALK ANIMATION
		.db 	_damage 			;; DAMAGE
		.db		_hit_lag_cont		;; HIT LAG CONT
		.db 	_type 				;; TYPE OF ENEMY (0 = basic, 1 = proyectil)
.endm

en_x 			= 0 		en_y 			= 1
en_w 			= 2 		en_h 			= 3
en_sprite_image_l = 4		en_sprite_image_h = 5

en_vx			= 6 		en_vy 			= 7
en_upd_l 		= 8 		en_upd_h 		= 9
collision 		= 10
hit_lag 		= 11
en_coll_upd_l 	= 12		en_coll_upd_h 	= 13
en_hit_upd_l 	= 14		en_hit_upd_h 	= 15
en_walking_animation = 16
en_damage 		= 17		hit_lag_cont 	= 18
en_type 		= 19

;;	DEFINE AN ENEMY DEFALUT
.macro DefineEnemyDefault _name, _suf
	DefineEnemy _name'_suf, #4, #96, #4, #32, _sprites1_sp_06, #1, #0, enemy_move, #0, #10, enemy_next_to_player, enemy_delete, #0, #15, #0, #0
.endm

;; DEFINE A VECTOR OF ENEMIES
.macro DefineEnemyVector _name, _n
	_c = 0
	.rept _n
		DefineEnemyDefault _name, \_c
		_c = _c + 1
	.endm
.endm

;;
;;	GLOBALES
;;
.globl enemy_vector
.globl enemy_delete
.globl enemy_default
.globl enemy_right
.globl enemy_collision_handler
.globl enemy_vector_generator_update
.globl enemy_vector_clear
.globl enemy_vector_update
.globl enemy_vector_draw
.globl enemy_vector_push
.globl enemy_vector_handler
.globl enemy_vector_destroy
.globl enemies_move_along_tilemap
.globl enemy_init_level
.globl enemy_vector_check_player_allowed