;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of Crimson Knight Adventures: An Amstrad CPC Game
;;  Copyright (C) 2018 Carlos Soler Mujeriego / Enrique Vidal Cayuela / Alejandro
;;  Gutiérrez Martínez
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------
.include "hud.h.s"
.include "main.h.s"
.include "cpctelera.h.s"
.include "player.h.s"
.include "renderer.h.s"

.area _CODE


;;num_pointer: .db #00, #01, #02, #03, #04, #05, #06, #07, #08, #09 

;;num_pointer: .dw _sprites3_sp_00, _sprites3_sp_01, _sprites3_sp_02, _sprites3_sp_03, _sprites3_sp_04, _sprites3_sp_05, _sprites3_sp_06, _sprites3_sp_07, _sprites3_sp_08, _sprites3_sp_09


;;Los valores de inicio de estos numeros hay que ponerlos en set_timer y set_score

;;
;; SCORE
;;

score_string: .asciz "Score:"
DefineString hud_score, #18, #80, #15, #4, score_string
score: .db #00, #00, #00, #00
score_pos_aux: .db #0, #0
score_pos_ini: .db #44, #80

;;
;; TIMER
;;
time_string: .asciz "Time :"
DefineString time_score, #18, #96, #15, #4, time_string
timer: .db #01, #00, #00, #00
timer_pos_aux: .db #0, #0
timer_pos_ini: .db #44, #96

;;
;; TOTAL SCORE
;;
total_string: .asciz "Total:"
DefineString total_score, #18, #112, #15, #4, total_string
total_pos_aux: .db #0, #0
total_pos_ini: .db #44, #112

sc_uni = 3
sc_dec = 2
sc_cen = 1
sc_mil = 0

sc_x 	= 0
sc_y 	= 1

incremento = 4

hud_score_1:  .db 	#06, #173, #4, #16
			  .dw _sprites3_sp_01

hud_score_2:  .db	#10, #173,  #4, #16
			  .dw _sprites3_sp_01
			  
hud_score_3:  .db	#14, #173,  #4, #16
			  .dw _sprites3_sp_01

hud_score_4:  .db	#18, #173, #4, #16
			  .dw _sprites3_sp_01


hud_timer_1:  .db 	#58, #173,  #4, #16
			  .dw _sprites3_sp_01

hud_timer_2:  .db 	#62, #173,  #4, #16
			  .dw _sprites3_sp_00

hud_timer_3:  .db 	#66, #173,  #4, #16
			  .dw _sprites3_sp_00

hud_timer_4:  .db 	#70, #173,  #4, #16
			  .dw _sprites3_sp_00



hud_helmet_1:  .db 	#32, #178,  #4, #16
			  .dw _sprites3_sp_16

hud_helmet_2:  .db 	#38, #178,  #4, #16
			  .dw _sprites3_sp_16

hud_helmet_3:  .db 	#44, #178,  #4, #16
			  .dw _sprites3_sp_16

			  
hud_health_bar: .db #35, #164, #10, #8, #0xD0
          ;;          x,   y,   w,   h, color
hb_x      = 0
hb_y      = 1
hb_w      = 2
hb_h      = 3
hb_col    = 4


hud_set_all:
	
	call set_timer
	call set_score

ret

hud_update:

	call update_health
	call update_score
	call countdown
	call update_timer

ret


set_timer:

	ld ix, #timer
 	
 	ld a, (actual_level)
 	cp #1
 	jr z, level_1
 	cp #2
 	jr z, level_1
 	cp #3
 	jr z, level_2
 	cp #4
 	jr z, level_3
 	cp #5
 	jr z, level_4
 	cp #6
 	jr z, level_4
 	cp #7
 	jr z, level_5

 	level_1: 
	ld sc_uni(ix), #00
	ld sc_dec(ix), #00
	ld sc_cen(ix), #05
	ld sc_mil(ix), #00
	jr end_timer

	level_2: 
	ld sc_uni(ix), #00
	ld sc_dec(ix), #00
	ld sc_cen(ix), #06
	ld sc_mil(ix), #00
	jr end_timer

	level_3: 
	ld sc_uni(ix), #00
	ld sc_dec(ix), #00
	ld sc_cen(ix), #08
	ld sc_mil(ix), #00
	jr end_timer

	level_4: 
	ld sc_uni(ix), #00
	ld sc_dec(ix), #00
	ld sc_cen(ix), #00
	ld sc_mil(ix), #01
	jr end_timer

	level_5: 
	ld sc_uni(ix), #00
	ld sc_dec(ix), #00
	ld sc_cen(ix), #05
	ld sc_mil(ix), #01
	jr end_timer


	end_timer:
ret

set_score:

	ld ix, #score
	ld sc_uni(ix), #00
	ld sc_dec(ix), #00
	ld sc_cen(ix), #00
	ld sc_mil(ix), #00

ret



update_timer:

	ld 	iy, #timer
	ld 	ix, #hud_timer_1

	ld   a, sc_mil(iy)
	call hud_update_sprite_of_a_number

	ld 	ix, #hud_timer_2
	ld   a, sc_cen(iy)
	;;ld  hb_col(ix), a
	call hud_update_sprite_of_a_number

	ld 	ix, #hud_timer_3
	ld   a, sc_dec(iy)
	;;ld  hb_col(ix), a
	call hud_update_sprite_of_a_number

	ld 	ix, #hud_timer_4
	ld   a, sc_uni(iy)
	;;ld  hb_col(ix), a
	call hud_update_sprite_of_a_number

ret


update_score:

	ld 	iy, #score
	ld 	ix, #hud_score_1
	ld   a, sc_mil(iy)
	;;ld  hb_col(ix), a
	call hud_update_sprite_of_a_number

	ld 	ix, #hud_score_2
	ld   a, sc_cen(iy)
	;;ld  hb_col(ix), a
	call hud_update_sprite_of_a_number

	ld 	ix, #hud_score_3
	ld   a, sc_dec(iy)
	;;ld  hb_col(ix), a
	call hud_update_sprite_of_a_number

	ld 	ix, #hud_score_4
	ld   a, sc_uni(iy)
	;;ld  hb_col(ix), a
	call hud_update_sprite_of_a_number

ret


inc_unidades:
	ld 	iy, #score
	ld   a, sc_uni(iy)
	cp   a, #09
	jr  nz, inc_uni

		ld sc_uni(iy), #00
		jp inc_decenas

	inc_uni:
	inc a
	ld  sc_uni(iy), a
ret


inc_decenas:
	ld 	iy, #score
	ld   a, sc_dec(iy)
	cp   a, #09
	jr  nz, inc_dec

		ld sc_dec(iy), #00
		jp inc_centenas

	inc_dec:
	inc a
	ld  sc_dec(iy), a
ret


inc_centenas:
	ld 	iy, #score
	ld   a, sc_cen(iy)
	cp   a, #09
	jr  nz, inc_cent

		ld sc_cen(iy), #00
		jp inc_millar

	inc_cent:
	inc a
	ld  sc_cen(iy), a
ret


inc_millar:
	ld 	iy, #score
	ld   a, sc_mil(iy)
	cp   a, #09
	jr  nz, inc_mil

		ret

	inc_mil:
	inc a
	ld  sc_mil(iy), a
ret

countdown:

	ld ix, #timer

	ld   a, sc_uni(ix)
	cp  #00
	jr   z, dec_decenas
		dec a
		ld sc_uni(ix), a
		jp end_countdown

	dec_decenas: 
	ld   a, sc_dec(ix)
	cp  #00
	jr   z, dec_centenas
		ld sc_uni(ix), #9
		dec a
		ld sc_dec(ix), a
		jp end_countdown

	dec_centenas: 
	ld   a, sc_cen(ix)
	cp  #00
	jr   z, dec_millar
		ld sc_uni(ix), #9
		ld sc_dec(ix), #9
		dec a
		ld sc_cen(ix), a
		jp end_countdown

	dec_millar: 
	ld   a, sc_mil(ix)
	cp  #00
	jr   z, muerte
		ld sc_uni(ix), #9
		ld sc_dec(ix), #9
		ld sc_cen(ix), #9
		dec a
		ld sc_mil(ix), a
		jp end_countdown

	muerte:
	ld ix, #player
	ld e_life(ix), #-1

	end_countdown:
ret

update_health:

	ld ix, #player
	ld  a, e_life(ix)
	ld ix, #hud_health_bar

	ld hb_w(ix), #1
	ld hb_col(ix), #00

	cp  a, #01 					;; Compara a con 1
	jp  m, end_update_health 	;; Si es menor de 1 se queda como esta
	ld hb_col(ix), #0xCF
	ld hb_w(ix), #1 			;; Si es mayor que uno se pone la dimension a 1

	cp  a, #20					;; Compara a con el 20% (4)
	jp  m, end_update_health 	;; Si es menor del 20% se queda como esta
	ld hb_w(ix), #2 			;; Si es mayor que el 20% se pone la dimension a 2

	cp  a, #30					;; Compara a con el 30% (4)
	jp  m, end_update_health 	;; Si es menor del 30% se queda como esta
	ld hb_w(ix), #3 			;; Si es mayor que el 30% se pone la dimension a 2

	cp  a, #40					;; Compara a con el 40% (4)
	jp  m, end_update_health 	;; Si es menor del 40% se queda como esta
	ld hb_w(ix), #4 			;; Si es mayor que el 40% se pone la dimension a 2

	cp  a, #50					;; Compara a con el 50% (4)
	jp  m, end_update_health 	;; Si es menor del 50% se queda como esta
	ld hb_w(ix), #5 			;; Si es mayor que el 50% se pone la dimension a 2

	cp  a, #60					;; Compara a con el 60% (4)
	jp  m, end_update_health 	;; Si es menor del 60% se queda como esta
	ld hb_w(ix), #6 			;; Si es mayor que el 60% se pone la dimension a 2

	cp  a, #70					;; Compara a con el 70% (4)
	jp  m, end_update_health 	;; Si es menor del 70% se queda como esta
	ld hb_w(ix), #7 			;; Si es mayor que el 70% se pone la dimension a 2

	cp  a, #80					;; Compara a con el 80% (4)
	jp  m, end_update_health 	;; Si es menor del 80% se queda como esta
	ld hb_w(ix), #8 			;; Si es mayor que el 80% se pone la dimension a 2

	cp  a, #90					;; Compara a con el 90% (4)
	jp  m, end_update_health 	;; Si es menor del 90% se queda como esta
	ld hb_w(ix), #9		    	;; Si es mayor que el 90% se pone la dimension a 2

	cp  a, #100				;; Compara a con el 100% (4)
	jp  m, end_update_health 	;; Si es menor del 100% se queda como esta
	ld hb_w(ix), #10 			;; Si es mayor que el 100% se pone la dimension a 2

	end_update_health:
ret


;;====================================================
;; 	DEVUELVE EL NOMBRE DEL SPRITE DEL NUMERO A COLOCAR		-		call hud_get_sprite_name
;;--------------------------------------------------
;;
;;	DESC.:		- Si un numero es, por ejemplo, 1 te devuelve en HL el nombre del sprite que representa el 1.
;;
;; 	RECIBE:		- A: Numero
;;
;; 	DESTRUYE:	- HL --> Te devuelve la direccion correspondiente.
;;
;;====================================================

;;IMPORTANTE: ESTE METODO SE PUEDE OPTIMIZAR CON UNA CONCATENACION.
hud_get_sprite_name:

	;;En A estara el numero que queremos
	cp #1
	jr z, devuelve_numero_1
	cp #0
	jr z, devuelve_numero_0
	cp #2
	jr z, devuelve_numero_2
	cp #3
	jr z, devuelve_numero_3
	cp #4
	jr z, devuelve_numero_4
	cp #5
	jr z, devuelve_numero_5
	cp #6
	jr z, devuelve_numero_6
	cp #7
	jr z, devuelve_numero_7
	cp #8
	jr z, devuelve_numero_8
	cp #9
	jr z, devuelve_numero_9
	cp #16
	jr z, devuelve_sprite_icono_vida_1
	cp #17
	jr z, devuelve_sprite_icono_vida_2

	devuelve_numero_0:
	ld hl, #_sprites3_sp_00
	ret
	devuelve_numero_1:
	ld hl, #_sprites3_sp_01
	ret
	devuelve_numero_2:
	ld hl, #_sprites3_sp_02
	ret
	devuelve_numero_3:
	ld hl, #_sprites3_sp_03
	ret
	devuelve_numero_4:
	ld hl, #_sprites3_sp_04
	ret
	devuelve_numero_5:
	ld hl, #_sprites3_sp_05
	ret
	devuelve_numero_6:
	ld hl, #_sprites3_sp_06
	ret
	devuelve_numero_7:
	ld hl, #_sprites3_sp_07
	ret
	devuelve_numero_8:
	ld hl, #_sprites3_sp_08
	ret
	devuelve_numero_9:
	ld hl, #_sprites3_sp_09
	ret

	devuelve_sprite_icono_vida_1:
	ld hl, #_sprites3_sp_16
	ret
	devuelve_sprite_icono_vida_2:
	ld hl, #_sprites3_sp_17
	ret
	
ret


;;====================================================
;; 	UPDATE SPRITE		-		call hud_update_sprite_of_a_number
;;--------------------------------------------------
;;
;;	DESC.:		- Actualiza el sprite que se debe colocar a esa ficha del HUD, ya sea score o temporizador
;;
;; 	RECIBE:		- A: Numero
;;
;; 	DESTRUYE:	- HL,A
;;
;;====================================================


hud_update_sprite_of_a_number:
	;;Actualizando el sprite
	call hud_get_sprite_name
	ld  hd_sprite_l(ix), l
	ld  hd_sprite_h(ix), h
 ret


hud_draw_score:
	ld (number), a
	ld a, sc_x(ix)
	ld c, a 			;; C = POS X
	ld a, sc_y(ix) 		
	ld b, a 			;; B = POS Y

	number = . + 1
	ld a, #0x00
	call draw_number
ret

hud_draw_all_score:
	call save_score_pos

	ld ix, #hud_score
	call render_draw_string

	ld ix, #score_pos_aux

	;; SCORE MIL
	ld iy, #score
	ld a, sc_mil(iy)
	call hud_draw_score

	ld ix, #score_pos_aux
	ld a, sc_x(ix)
	add a, #incremento
	ld sc_x(ix), a

	;; SCORE CEN
	ld iy, #score
	ld a, sc_cen(iy)
	call hud_draw_score

	ld ix, #score_pos_aux
	ld a, sc_x(ix)
	add a, #incremento
	ld sc_x(ix), a

	;; SCORE DEC
	ld iy, #score
	ld a, sc_dec(iy)
	call hud_draw_score

	ld ix, #score_pos_aux
	ld a, sc_x(ix)
	add a, #incremento
	ld sc_x(ix), a

	;; SCORE UNI
	ld iy, #score
	ld a, sc_uni(iy)
	call hud_draw_score

	;;
	;; 	TIMER
	;;
	ld ix, #time_score
	call render_draw_string

	ld ix, #timer_pos_aux

	;; SCORE MIL
	ld iy, #timer
	ld a, sc_mil(iy)
	call hud_draw_score

	ld ix, #timer_pos_aux
	ld a, sc_x(ix)
	add a, #incremento
	ld sc_x(ix), a

	;; SCORE CEN
	ld iy, #timer
	ld a, sc_cen(iy)
	call hud_draw_score

	ld ix, #timer_pos_aux
	ld a, sc_x(ix)
	add a, #incremento
	ld sc_x(ix), a

	;; SCORE DEC
	ld iy, #timer
	ld a, sc_dec(iy)
	call hud_draw_score

	ld ix, #timer_pos_aux
	ld a, sc_x(ix)
	add a, #incremento
	ld sc_x(ix), a

	;; SCORE UNI
	ld iy, #timer
	ld a, sc_uni(iy)
	call hud_draw_score
ret


save_score_pos:

	ld ix, #score_pos_ini
	ld iy, #score_pos_aux

	ld a, sc_x(ix)
	ld sc_x(iy), a

	ld a, sc_y(ix)
	ld sc_y(iy), a


	ld ix, #timer_pos_ini
	ld iy, #timer_pos_aux

	ld a, sc_x(ix)
	ld sc_x(iy), a

	ld a, sc_y(ix)
	ld sc_y(iy), a


	ld ix, #total_pos_ini
	ld iy, #total_pos_aux

	ld a, sc_x(ix)
	ld sc_x(iy), a

	ld a, sc_y(ix)
	ld sc_y(iy), a

ret



;;A: Helmet que se esta acutalizando: Si actualizas el 3, pon 3.
;;IX: Helmet que se va a actualizar.
update_helmet_icon:

	ld b, a

	;;Primer icono
	ld a, (actual_retrys)
	cp b
	jp p, change_sprite_to_active_helmet
		;;Hay que poner el casco gris
		ld a, #17
		jr end_set_sprite_helmet
		change_sprite_to_active_helmet:
		;;Hay que poner el casco con color
		ld a, #16
	end_set_sprite_helmet:
	call hud_update_sprite_of_a_number

ret

hud_update_all_score:

    ld iy, #timer
	ld a, sc_uni(iy)
	cp #0
	jp z, end_unidades
	loop_unidades:
		call hud_draw_all_score
		call cpct_waitVSYNC_asm         ;; Wait raster
    	call switch_buffers 
		call inc_unidades
		
		ld iy, #timer
		ld a, sc_uni(iy)
		dec a
		ld sc_uni(iy), a
		jp nz, loop_unidades
	end_unidades:

	ld iy, #timer
	ld a, sc_dec(iy)
	cp #0
	jp z, end_decenas
	loop_decenas:
		call hud_draw_all_score
		call cpct_waitVSYNC_asm         ;; Wait raster
    	call switch_buffers 
		call inc_decenas
		
		ld iy, #timer
		ld a, sc_dec(iy)
		dec a
		ld sc_dec(iy), a
		jp nz, loop_decenas
	end_decenas:

	ld iy, #timer
	ld a, sc_cen(iy)
	cp #0
	jp z, end_centenas
	loop_centenas:
		call hud_draw_all_score
		call cpct_waitVSYNC_asm         ;; Wait raster
    	call switch_buffers 
		call inc_centenas
		
		ld iy, #timer
		ld a, sc_cen(iy)
		dec a
		ld sc_cen(iy), a
		jp nz, loop_centenas
	end_centenas:

	ld iy, #timer
	ld a, sc_mil(iy)
	cp #0
	jp z, end_millar
	loop_millar:
		call hud_draw_all_score
		call cpct_waitVSYNC_asm         ;; Wait raster
    	call switch_buffers 
		call inc_millar
		
		ld iy, #timer
		ld a, sc_mil(iy)
		dec a
		ld sc_mil(iy), a
		jp nz, loop_millar
	end_millar:

	call hud_draw_all_score
	call cpct_waitVSYNC_asm         ;; Wait raster
    call switch_buffers

    call hud_draw_all_score
	call cpct_waitVSYNC_asm         ;; Wait raster
    call switch_buffers 
ret