;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of Crimson Knight Adventures: An Amstrad CPC Game
;;  Copyright (C) 2018 Carlos Soler Mujeriego / Enrique Vidal Cayuela / Alejandro
;;  Gutiérrez Martínez
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------
;;============================================
;;
;; DECLARACIONES GLOBALES DEL MAIN
;;
;;============================================
.globl music_play
.globl cpct_akp_stop_asm
.globl cpct_disableFirmware_asm
.globl cpct_setVideoMode_asm
.globl cpct_getScreenPtr_asm
.globl cpct_drawSolidBox_asm
.globl cpct_setInterruptHandler_asm
.globl cpct_akp_musicInit_asm
.globl cpct_akp_musicPlay_asm
.globl cpct_scanKeyboard_if_asm
.globl cpct_isKeyPressed_asm
.globl cpct_waitVSYNC_asm
.globl cpct_isAnyKeyPressed_asm 
.globl cpct_getRandom_mxor_u8_asm
.globl cpct_zx7b_decrunch_s_asm
.globl cpct_setPalette_asm
.globl cpct_etm_drawTilemap4x8_ag_asm
.globl cpct_setVideoMemoryPage_asm
.globl cpct_etm_setDrawTilemap4x8_ag_asm
.globl cpct_drawSprite_asm
.globl cpct_hflipSpriteM0_asm

.globl cpct_drawStringM0_asm
.globl cpct_setDrawCharM0_asm
.globl cpct_drawCharM0_asm

.globl decompress_buffer   
.globl levelmaxsize                 
.globl decompress_buffer_end 
.globl decompress_buffer_end2 

.globl cpct_setPALColour_asm

.globl _palette

.globl _song_ingame

;;.globl _mapaPruebas_pack_OFF_001
;;.globl _mapaPruebas2_pack_OFF_001

.globl _mapaPruebas_pack_end
.globl _mapaPruebas2_pack_end
.globl _mapaPruebas3_pack_end
.globl _mapaPruebas4_pack_end
.globl _mapaPruebas5_pack_end


.globl _mapaPrueba_W
.globl _mapaPrueba_H

.globl _mapaPrueba2_W
.globl _mapaPrueba2_H

.globl _mapaPrueba3_W
.globl _mapaPrueba3_H

.globl _mapaPrueba4_W
.globl _mapaPrueba4_H

.globl _mapaPrueba5_W
.globl _mapaPrueba5_H


.globl end_level_scroll_map_1_2
.globl end_level_scroll_map_3
.globl end_level_scroll_map_4
.globl end_level_scroll_map_5_6
.globl end_level_scroll_map_7

.globl game_state

.globl screen_movement

.globl player_movement
.globl is_player_movement_allowed
.globl player_screen_position
.globl screen_scroll_position

.globl actual_level

.globl actual_retrys

;;Sprites:



   .globl _sprites1_sp_15
   .globl _sprites1_sp_14
   .globl _sprites1_sp_13
   .globl _sprites1_sp_12
   .globl _sprites1_sp_11
   .globl _sprites1_sp_10
   .globl _sprites1_sp_09
   .globl _sprites1_sp_08
   .globl _sprites1_sp_07
   .globl _sprites1_sp_06
   .globl _sprites1_sp_05
   .globl _sprites1_sp_04
   .globl _sprites1_sp_03
   .globl _sprites1_sp_02
   .globl _sprites1_sp_01
   .globl _sprites1_sp_00


   .globl _sprites2_sp_3
   .globl _sprites2_sp_2
   .globl _sprites2_sp_1
   .globl _sprites2_sp_0


   .globl _sprites3_sp_17
   .globl _sprites3_sp_16
   .globl _sprites3_sp_15
   .globl _sprites3_sp_14
   .globl _sprites3_sp_13
   .globl _sprites3_sp_12
   .globl _sprites3_sp_11
   .globl _sprites3_sp_10
   .globl _sprites3_sp_09
   .globl _sprites3_sp_08
   .globl _sprites3_sp_07
   .globl _sprites3_sp_06
   .globl _sprites3_sp_05
   .globl _sprites3_sp_04
   .globl _sprites3_sp_03
   .globl _sprites3_sp_02
   .globl _sprites3_sp_01
   .globl _sprites3_sp_00

   ;;.globl _welcome_sp
   .globl _start_sp
   .globl _game_over_sp
   .globl _win_sp

   .globl end_level_position
;;========== ESTRUCTURA DE LA MEMORIA DEL PROGRAMA: ============== ;;DECOMPRESS-TILE TESTS

;;Song ingame start: 0x0040 (1121 size)
;;Song ingame end: 0x4a0 (el ultimo byte de musica es el byte de antes de esta cifra)



;;==========COMPRESSION 


decompress_buffer       =  0x2a7       ;;La musica acaba en este byte. Decompress buffer indica DONDE se deben descomprimir los archivos.
tilemap_ptr             = decompress_buffer + 0 ;;El TILEMAP es nuestro primer elemento del pack.


;;==========NIVEL 1========

levelmaxsize            =  0x09E0      ;;AQUI SE DEBE PONER EL TAMANYO DEL PACK UNCOMPRESSED. El mapa mas grande creado es de  bytes. LevelMaxSize indica cuanto ocupa el mapa que mas ocupa.
decompress_buffer_end   =  decompress_buffer + levelmaxsize - 1  ;;La descompresion acaba despues del nivel, para ello le sumamos donde empieza la descompresion a cuanto ocupa la descompresion. Se pone -1 porque acaba en el byte anterior.


;;*OJO*. Elemento potencialmente peligroso:
                                              ;;800
tileset_ptr             =  decompress_buffer + 960 ;;3200 = _mapaPruebas_pack_OFF_001 
                                                   ;;Esto apunta al inicio del TILESET, que va justo despues del tilemap guardado en el pack. 
                                                   ;;_pack_OFF_001 representa donde empieza el segundo elemento del pack, que es un tileset.


;;==========NIVEL 2========


levelmaxsize2            =  0x09E0     ;;AQUI SE DEBE PONER EL TAMANYO DEL PACK UNCOMPRESSED. El mapa mas grande creado es de  bytes. LevelMaxSize indica cuanto ocupa el mapa que mas ocupa.
decompress_buffer_end2   =  decompress_buffer + levelmaxsize2 - 1  ;;La descompresion acaba despues del nivel, para ello le sumamos donde empieza la descompresion a cuanto ocupa la descompresion. Se pone -1 porque acaba en el byte anterior.
tileset_ptr_2             = decompress_buffer + 960 ;;_PACK_OFF_1

;;tileset_ptr_level1 =


;;==========NIVEL 3========


levelmaxsize3            =  0x0AD0      ;;AQUI SE DEBE PONER EL TAMANYO DEL PACK UNCOMPRESSED. El mapa mas grande creado es de  bytes. LevelMaxSize indica cuanto ocupa el mapa que mas ocupa.
decompress_buffer_end3   =  decompress_buffer + levelmaxsize3 - 1  ;;La descompresion acaba despues del nivel, para ello le sumamos donde empieza la descompresion a cuanto ocupa la descompresion. Se pone -1 porque acaba en el byte anterior.
tileset_ptr_3             = decompress_buffer + 1200 ;;_PACK_OFF_1


;;==========NIVEL 4========


levelmaxsize4            =  0x0AD0      ;;AQUI SE DEBE PONER EL TAMANYO DEL PACK UNCOMPRESSED. El mapa mas grande creado es de  bytes. LevelMaxSize indica cuanto ocupa el mapa que mas ocupa.
decompress_buffer_end4   =  decompress_buffer + levelmaxsize4 - 1  ;;La descompresion acaba despues del nivel, para ello le sumamos donde empieza la descompresion a cuanto ocupa la descompresion. Se pone -1 porque acaba en el byte anterior.
tileset_ptr_4             = decompress_buffer + 1200 ;;_PACK_OFF_1


;;==========NIVEL 5========


levelmaxsize5            =  0x0C60     ;;AQUI SE DEBE PONER EL TAMANYO DEL PACK UNCOMPRESSED. El mapa mas grande creado es de  bytes. LevelMaxSize indica cuanto ocupa el mapa que mas ocupa.
decompress_buffer_end5   =  decompress_buffer + levelmaxsize5 - 1  ;;La descompresion acaba despues del nivel, para ello le sumamos donde empieza la descompresion a cuanto ocupa la descompresion. Se pone -1 porque acaba en el byte anterior.
tileset_ptr_5             = decompress_buffer + 1600 ;;_PACK_OFF_1





;;===================================




;;PASOS PARA ANYADIR MAS NIVELES

;;1. Debes crear el tilemap en tilemap_conversion.mk
;;2. Debes crear el tileset si es necesario en image_conversion.mk
;;3. Crea el pack de compresion en compresion.mk
;;4. Aqui, en main, crea las variables adecuadas. MaxSize: Sacalo del h.s. del paquete. Ej: _mapaPruebas2_pack_size y conviertelo a HEXADECIMAL.
;;5. Incluye en main.s con "include" el archivo del NIVEL. EJEMPLO: .include "level1.h.s" .include "level2.h.s"
;;6. Vas a necesitar incluir variables globales en main.h.s. Como: .globl decompress_buffer_end2 .globl _mapaPruebas2_pack_end .globl _mapaPrueba2_W .globl _mapaPrueba2_H
;;7. En main.s, end_level_scroll_map indica cuantos "pasos" debes dar para pasarte cada nivel. Depende de nuestra programacion, de momento lo hacemos asi.
;;8. En renderer, esta el control de que nivel debe cargarse y como. Cambia los parametros en los metodos necesarios.